(DEFUN ssscript    (/ akey alldwg cmdlist1 cnt count dwglist dwgname 
                   filename fp frompath letr startstring tempname valid 
                   option1 option2 option3 option4 option5 option6 option7
                   option8 option9 option10)
;****************************
;SSS.lsp
;Scott's Super Scripting Utility
;Set up to use "~" as a hard return for
;commands that require it.
;November 28, 1995
;Scott McBride 71413,451
;****************************
;Error Trapping routine
(defun *error* (s)
   (setvar "cmdecho" 1)
   (close fil1)
   (princ s)
   (terpri))
(textscr)                                        ;flip to the text screen.
(setvar "cmdecho" 0)                             ;turn off the screen echo 
;
;****** INITIALIZE VARIABLES ********
;
(if (= (getvar "dbmod") 0)                       ;determines the status of the
   (setq startstring "_.open ")                  ;drawing on screen so that it
   (setq startstring "_.open n ")                ;can get the open command right
)
(setq valid 0)                                   ;flag used for file selection
;
;************************************************
;Use this section to store scripts for menu choices
;************************************************
(setq option1 "")
(setq option2 "")
(setq option3 "")
(setq option4 "")
(setq option5 "")
(setq option6 "")
(setq option7 "")
(setq option8 "")
(setq option9 "")
(setq option10 "point~0,0~point~36,24~point~18,23.875")
;***********************************************
(prompt  "\n\n\n                       ")
(prompt  "\n     ********   SCOTT'S SCRIPTER   ********  ")
(prompt  "\n              Select Stored Script  ")
(prompt  "\n")
(prompt  "\n         1.  Option 1 Not Programmed")
(prompt  "\n         2.  Option 2 Not Programmed")
(prompt  "\n         3.  Option 3 Not Programmed")
(prompt  "\n         4.  Option 4 Not Programmed")
(prompt  "\n         5.  Option 5 Not Programmed")
(prompt  "\n         6.  Option 6 Not Programmed")
(prompt  "\n         7.  Option 7 Not Programmed")
(prompt  "\n         8.  Option 8 Not Programmed")
(prompt  "\n         9.  Option 9 Not Programmed")
(prompt  "\n        10.  Place Points for D-size sheet")
(prompt  "\n        11. MAKE YOUR OWN SCRIPT")
(initget(+ 1 2 4) "1 2 3 4 5 6 7 8 9 10 11")
(setq choice (getkword "\n\n      Enter Your Choice:"))
(cond
   ((= choice "1")  (setq cmdlist1 option1))
   ((= choice "2")  (setq cmdlist1 option2))
   ((= choice "3")  (setq cmdlist1 option3))
   ((= choice "4")  (setq cmdlist1 option4))
   ((= choice "5")  (setq cmdlist1 option5))
   ((= choice "6")  (setq cmdlist1 option6))
   ((= choice "7")  (setq cmdlist1 option7))
   ((= choice "8")  (setq cmdlist1 option8))
   ((= choice "9")  (setq cmdlist1 option9))
   ((= choice "10") (setq cmdlist1 option10))
   ((= choice "11")
      (prompt  "\n\n\n                       ")
      (prompt  "\n     ********   SCOTT'S SCRIPTER   ********  ")
      (prompt  "\n                                           ")
      (prompt  "\n     Enter Script String   ")
      (prompt  "\n     Using a ~ charater for hard returns.")
      (prompt  "\n\n\n                                       ")
      (while (/= valid 2)
         (prompt  "\n                                       ")
         (setq cmdlist1 (getstring T "\n Script:"))
         (prompt  "\n\n\n  Is Script Correct? <Y>:")
         (initget "Y N")
         (setq akey (getkword))
         (if (= akey "N")(SETQ VALID 1)(SETQ VALID 2))
      );end while
   );end choice 11
);end cond 
(setq valid 0)                                   ;flag used for file selection
;***********************************************
(while (/= valid 2)
   (prompt  "\n     ********   SCOTT'S SCRIPTER   ********  ")
   (prompt  "\n\n     Enter path of drawings to be processed  ")
   (prompt  "\n     Hit <return> for default directory      ")
   (prompt  "\n\n\n                                       ")
   (prompt  " \n    Use form ...  C:\\ACAD\\JOB# ")
   (setq frompath (getstring "\n\n  Enter the path: "))
   (if (and (/= frompath "")(/= (substr frompath (strlen frompath))(chr 92)))
      (setq frompath (strcat frompath (chr 92)))
   );endif
   (prompt  "\n\n\n                       ")
   (prompt  "\n     ********   SCOTT'S SCRIPTER   ********  ")
   (prompt  "\n                                         ")
   (prompt "\n     Enter Drawing File Mask...")
   (prompt "\n\n     Example- to process all files that are named 4670????.dwg")
   (prompt "\n              type 4670*  ")
   (prompt "\n\n     or press ENTER for all dwg's in this subdirectory")
   (setq filename (getstring "\n\n  Enter the Filename(s):"))
   (if (= filename "")(setq filename "*"))
   (prompt  "\n\n\n                       ")
   (prompt  "\n     ********   SCOTT'S SCRIPTER   ********  ")
   (prompt  "\n                                         ")
   (prompt  "\n                  Drawing Menu           ")
   (prompt  "\n                                         ")
   (prompt  "\n           1.  Select All Drawings           ")
   (prompt  "\n           2.  Review each Drawing           ")
   (prompt  "\n\n                                   ")
   (initget (+  1 2 4 ) "1 2")
   (setq alldwg (getkword"\n Enter Your Choice:"))
   (prompt  " \n\n\n    Reading in Drawing names....\n\n\n ")
   (command "shell" (strcat "DIR " frompath filename ".DWG|SORT > DWG.DIR"))
   (setq dwglist ())                                ;declare dwglist as a list
   (setq fil1 (open "dwg.dir" "r"))                 ;open "dwg.dir"
   (while (setq dwgname (read-line fil1))           ;read dwgname until end of file
      (if (and (> (strlen dwgname) 0)               ;if 1st char exists not a <cr>
               (not (equal (substr dwgname 1 1) " "));and 1st char isn't a blank       
          );end and     
      (progn                                        ;if-then strip off file size and date
         (setq tempname "" count 1)                 ;start a new word with no letters
         (while (not (equal (setq letr (substr dwgname count 1)) " "));ADD LETTER
            (setq tempname (strcat tempname letr)   ; FROM DWGNAME UNLESS ITS A SPACE
                  count (1+ count))
         );end while
         (setq dwgname tempname)
         (princ(strcat "\n           " dwgname (substr "            ? <N>: " (strlen dwgname))))
         ;*********   DRAWING LIST MANIPULATION   ***********
         (if (=  alldwg "2")
            (progn
               (initget "Y N")
               (setq akey (getkword))
            );end progn
         );endif
         (if (or (= alldwg "1")(and (= alldwg "2")(= akey "Y")))
            (progn
               (setq dwglist (cons dwgname dwglist))
               (princ "           ADD")
            );end progn end then
            (princ "           SKIP");else skip
         );end if
      );end progn took care of one name.
      );end if ... checked for standard drawing name
   );end while ... finished entire list
   (close fil1)
   (if (/= dwglist nil)(setq valid 2)(progn(setq valid 1)(prompt "\n\n\n  No Files Selected Try AGAIN! \n\n\n")))
);end while
(prompt  " \n\n\n           End of Drawing Names....\n\n\n ")
(command "shell" "del dwg.dir" )                    ;Erase drawing directory
(setq dwglist (reverse dwglist))
(setq fp (open "sss.scr" "w"))
(while (/= dwglist nil)
   (write-line (strcat startstring frompath (car dwglist) ) fp)
   (setq tmp "" cnt 0)
   (while (< cnt (strlen cmdlist1))
      (setq cnt (1+ cnt))
      (if (= (substr cmdlist1 cnt 1) "~")           ;chatater is a ~
         ;then
         (progn
            (write-line tmp fp)
            (setq tmp "")
         ); end then progn
         ;else
         (setq tmp (strcat tmp (substr cmdlist1 cnt 1)))
      );end if
   ); end while
   (if (/= tmp nil)(write-line tmp fp))
   (write-line ".zoom e .save " fp)
   (setq dwglist (cdr dwglist))
   (setq startstring ".open ")
);end while
(write-line "scott's_scripter_complete" fp);faults script 
(setq fp (close fp))
(command "script" "sss")
);end of defun

(defun c:sss()
	(ssscript)
)

